/* longmod.h
 *
 * Copyright (c) 2016 Ghent University
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef NUTFILTER_LONGMOD_H
#define NUTFILTER_LONGMOD_H

int longmod_reduce_matrix(int nv, INT_ADJ_MATRIX_PTR matrix);

int inverse_longmod_matrix(int nv, INT_ADJ_MATRIX_PTR matrix);

unsigned int longmod_norm_bit_vector(unsigned int b, int nv);

int longmod_nut_property(unsigned int b, int nv);

int longmod_is_nucifer(int nv, INT_ADJ_MATRIX_PTR matrix);

int longmod_reduce_matrix(int nv, INT_ADJ_MATRIX_PTR matrix);

int check_zeroless_kernel_vector_longmod(int nv, INT_ADJ_MATRIX_PTR matrix);

// for profiling
int longmod_nut_property_with_count(unsigned int b, int nv);
void longmod_print_counts (int nv);


#endif //NUTFILTER_LONGMOD_H
